package body List is

	function Size (L : List) return Natural is
	begin
		return L.LSize;
	end Size;
	
	
	function IsEmpty (L : List) return Boolean is
	begin
		return L.LSize = 0;
	end IsEmpty;
	
	
	function Value (L : List) return ItemType is
	begin
		if L.Actual /= NULL then
			return L.Actual.Item;
		else
			raise CONSTRAINT_ERROR;
		end if;
	end Value;
	

	procedure Empty (L : in out List) is
	begin
		L.Header := new ListMember;
		L.Actual := L.Header;
		L.LSize  := 0;
	end;
	
	procedure First (L : in out List) is
	begin
		L.Actual := L.Header.Next;
	end First;
	

	procedure Next (L : in out List) is
	begin
		if L.Actual /= NULL then
			L.Actual := L.Actual.Next;
		else
			raise CONSTRAINT_ERROR;
		end if;
	end Next;
	
	
	procedure Insert (L : in out List; E : in ItemType) is
		N: ListMemberP;
	begin
		N := new ListMember;
		N.Item := E;
		if L.Actual /= NULL then
			N.Next := L.Actual.Next;
			L.Actual.Next := N;
		end if;
		L.Actual := N;
		L.LSize := L.LSize + 1;
	end Insert;
	
end List;