generic
	type ItemType is private;
	
package List is

	type List is private;
	type ListMember is private;
	
	function	IsEmpty	(L : List) return Boolean;
	--function	IsError (L : List) return Boolean;
	function	Value	(L : List) return ItemType;
	function	Size	(L : List) return Natural;
	procedure	Empty	(L : in out List);
	procedure	First	(L : in out List);
	procedure	Next	(L : in out List);
	procedure	Insert	(L : in out List; E : in ItemType);

	
	private
		Type ListMemberP is Access all ListMember;
		Type ListMember is record
			Item:	ItemType;
			Next:	ListMemberP := NULL;
		end record;
		
		Type List is record
			Header : ListMemberP	:= new ListMember;
			Actual : ListMemberP	:= NULL;
			LSize  : Natural	:= 0;
			Member : ListMember;
		end record;
		
	
end List;
