with Text_IO, Ada.Command_Line, List, Map;
use  Text_IO, Ada.Command_Line, Map;

procedure main is

	package Char_List is new List (Character);
	use Char_List;
	
	type StringP is Access all String;
	
	FILETYPE_ERROR		: Exception;
	CMDLINE_ERROR		: Exception;
	
	Association_File	: File_Type;
	Input_File		: File_Type;
	Output_File		: File_Type;
	
	Associations1		: Char_List.List;
	Associations2		: Char_List.List;
	ReadText		: Char_List.List;
	AssocMap		: Map.Map;
	AssocMember1		: StringP;
	AssocMember2		: StringP;
	C			: Character;
	Row			: Integer	:= 1;
	
begin
	Empty (Associations1);
	Empty (Associations2);
	Empty (ReadText);
	Empty (AssocMap);

	if Argument_Count /= 2 then
		raise CMDLINE_ERROR;
	end if;

	new_line;
	
	open (Association_File, In_File, Name => Argument(1));
	while not end_of_file(Association_File) loop
		declare
		begin
			while not end_of_line(Association_File) loop
				
				Get (Association_File, C);
				while C /= ' ' and C /= Ascii.HT and not end_of_line(Association_File) loop
					Insert (Associations1, C);
					Get (Association_File, C);
				end loop;
				if end_of_line(Association_File) then raise FILETYPE_ERROR; end if;
				
				Get (Association_File, C);
				while C /= ' ' and C /= Ascii.HT and not end_of_line(Association_File) loop
					Insert (Associations2, C);
					Get (Association_File, C);
				end loop;
				if end_of_line(Association_File) then
					Insert (Associations2, C);
				else
					raise FILETYPE_ERROR;
				end if;
				
				AssocMember1 := new String (1..Size(Associations1));
				First(Associations1);
				for i in AssocMember1'range loop
					AssocMember1.All(i) := Value (Associations1);
					Next(Associations1);
				end loop;
				
				AssocMember2 := new String (1..Size(Associations2));
				First(Associations2);
				for i in AssocMember2'range loop
					AssocMember2.All(i) := Value (Associations2);
					Next(Associations2);
				end loop;
				
				Insert (AssocMap, AssocMember1.All, AssocMember2.All);
				put_line (AssocMember1.All & " " & AssocMember2.All);
				
			end loop;
		exception
			when FILETYPE_ERROR =>
				Put_Line ("Hiba a " & Integer'Image(Row) & ". sorban (file felepites)");
			when REPEAT_ERROR =>
				Put_Line ("Hiba a " & Integer'Image(Row) & ". sorban (kulcs ismetles)");
		end;
		
		skip_line(Association_File);
		Empty(Associations1);
		Empty(Associations2);
		Row := Row + 1;
		
	end loop;
	close (Association_File);
	
	open (Input_File, In_File, Name => Argument(2));
	create (Output_File, Out_File, Name => (Argument(2) & ".out"));
	
	while not end_of_file(Input_File) loop
		while not end_of_line(Input_File) loop
		
			Get (Input_File, C);
			while C /= ' ' and C /= Ascii.HT and not end_of_line(Input_File) loop
				Insert (ReadText, C);
				Get (Input_File, C);
			end loop;
			
			if end_of_line (Input_File) then
				Insert (ReadText, C);
			end if;
			
			AssocMember1 := new String (1..Size(ReadText));
			First(ReadText);
			for i in AssocMember1'range loop
				AssocMember1.All(i) := Value (ReadText);
				Next(ReadText);
			end loop;
			
			Put (Output_File, Map.Get (AssocMap, AssocMember1.All));
			if not end_of_line(Input_File) then
				Put (Output_File, C);
			end if;
			
			Empty (ReadText);
			
		end loop;
		skip_line (Input_File);
		new_line (Output_File);
		
	end loop;
	
	close (Input_File);
	close (Output_File);
	
	New_Line;
	Put_Line ("Sikeres csere a fajlban");
	
	-- ha nincsen ilyen file, akkor kiv�el
	exception
		when NAME_ERROR => Put_Line ("Nincsen ilyen file.");
		when CMDLINE_ERROR => Put_Line ("2 db fajlnev argumentum kell.");
	
end main;