package body Map is

	use Map_List;

	
	procedure Empty (M : in out Map) is
	begin
		Empty(Map_List.List(M));
	end Empty;

	
	procedure Insert (M : in out Map; Key : String; Data : String) is
		K: StringP;
		V: StringP;
	begin
		if Has (M, Key) then
			raise REPEAT_ERROR;
		else
			K := new String (Key'range);
			V := new String (Data'range);
			K.All := Key;
			V.All := Data;
			Insert (M, (K, V));
		end if;
	end Insert;
	
	
	function Has (M : Map; Key : String) return Boolean is
		MM : Map := M;
	begin
		First(MM);
		declare
		begin
			While Value(MM).Key.All /= Key loop
				Next(MM);
			end loop;
			return TRUE;
		end;
		exception when CONSTRAINT_ERROR => return FALSE;
	end Has;
	
	
	function Get (M : Map; Key : String) return String is
		MM : Map := M;
	begin
		First(MM);
		declare
		begin
			While Value(MM).Key.All /= Key loop
				Next(MM);
			end loop;
		end;
		return Value(MM).Value.All;
		exception when CONSTRAINT_ERROR => return Key;
	end Get;
	
end Map;