with List;

package Map is

	REPEAT_ERROR	: Exception;
	NOTFOUND_ERROR	: Exception;
	
	type Map is private;

	procedure	Empty	(M : in out Map);
	procedure	Insert	(M : in out Map; Key : String; Data : String);
	function	Has	(M : Map; Key : String) return Boolean;
	function	Get	(M : Map; Key : String) return String;
	
	private
		type StringP is Access all String;
		type MapType is record
			Key	: StringP;
			Value	: StringP;
		end record;
		
		package Map_List is new List (MapType);
		--use Map_List;
		type Map is new Map_List.List;
		
end Map;